diff -u --ignore-all-space p3nfs.pl7/CHANGES p3nfs.pl8/CHANGES
--- p3nfs.pl7/CHANGES	Wed Aug 17 18:44:54 1994
+++ p3nfs.pl8/CHANGES	Wed Oct 19 19:56:59 1994
@@ -18,3 +18,9 @@
   - Thank Juergen it should work on Linux
 pl6 (Around July 15.)
   - AIX port. Strange lockups when writing a file twice. (?!)
+pl7 (17.8.94) (from version.h)
+  - AIX port (untested) by Rudi.
+  - Lee McLoughlin updated the linux port.
+pl8 (13.10.94)
+  - possibly help for classic S3 users. added untested nfsc_S3.opl
+  - Added preliminary Solaris 2.3 support. gec
diff -u --ignore-all-space p3nfs.pl7/INSTALL p3nfs.pl8/INSTALL
--- p3nfs.pl7/INSTALL	Wed Aug 17 19:52:47 1994
+++ p3nfs.pl8/INSTALL	Wed Oct 19 19:51:57 1994
@@ -1,3 +1,8 @@
+This as a reminder for those who want to check for a newer version of
+the nfsd, but have forgotten the address:
+ftp.uni-erlangen.de:/pub/psion/local/
+ftp://src.doc.ic.ac.uk/packages/psion/icdoc/ (generic address)
+
 First of all:
   p3nfsd is not really an nfs daemon. You can't mount the psion  
   from another workstation, only from the one, where it is attached
@@ -7,8 +12,9 @@
 
 
 Porting
-  If your architecture is already supported then type make, else you
-  have to do some more first (see PORTING).
+  If your architecture is already supported then select the appropriate
+  setting in the Makefile and type make, else you have to do some more 
+  first (see PORTING).
 
 Supported Architectures:
   - SunOS 4.1.3
@@ -22,6 +28,11 @@
   - AIX 3.2
     Strange lockups when writing a file twice.
     Not well tested
+  - Solaris 2.3/2.4
+    as the program is using hardware flow control, check out that the
+    patch 102028-01 (Sept. 94) for RTS/CTS is applied to your kernel.
+    (If somebody needs the patch, and has NO other way to find it, ask
+    caronni@tik.ethz.ch) Tested on exactly two machines.
 
 Features:
   - type p3nfsd -help to see all options.
diff -u --ignore-all-space p3nfs.pl7/Makefile p3nfs.pl8/Makefile
--- p3nfs.pl7/Makefile	Thu Aug 18 20:40:39 1994
+++ p3nfs.pl8/Makefile	Wed Oct 19 14:40:17 1994
@@ -1,7 +1,24 @@
-CC	=	cc
+# For Sun 4.1.3:
+#CC	=	cc
+#CFLAGS	=	-g
+#LDFLAGS =
+
+# For Linux:
+#CC	=	cc
+#CFLAGS	=	-g -Wall
+#LDFLAGS =
+
+# For Solaris 2.3 with gcc
+#CC	=	gcc
+#CFLAGS	=	-g -Wall
+#LDFLAGS =	-lucb -lrpcsoc -lnsl -lsocket -L/usr/ucblib -R/usr/ucblib
+
+# For Solaris 2.3 --- you may need to define -D__svr4__ if !gcc
+CC	=	cc -D__svr4__
 CFLAGS	=	-g
-#CFLAGS	=	-g -Wall # -O6
-LDFLAGS =
+LDFLAGS =	-L/usr/ucblib -R/usr/ucblib -lucb -lrpcsoc -lnsl -lsocket
+
+
 
 AIXLIBS	=	-lbsd
 
@@ -13,21 +30,22 @@
 OBJS	=	$(MOBJS) #$(AIX_OBJS)
 
 # Default installdirectory applies to local installation at FAU
-BINDIR	=	/proj/psion/bin/sun4
+BINDIR	=	/proj/psion/bin/sun5
 
 $(PROGRAM):$(OBJS)
 	$(CC) $(LDFLAGS) -o $@ $(OBJS) #$(AIXLIBS)
 
 nfsc_S3.opl: nfsc.opl
+	@rm -f $@
 	echo >  $@ 'REM nfsc_S3 -- automatically created from nfsc -- do not edit' 
 	sed >> $@ < $? -e 's/\(rsset:[        ]*([    ]*\)16,/\115,/' \
-	    -e 's/uadd[     ]*\(([^,]*\),\([^)]*)\)/\1 + \2/g' 
-	chmod a-w $@
-	touch .$?
+	    -e 's/uadd[     ]*(/myuadd%:(/g' 
+	@chmod a-w $@
+	@touch .$?
 
 .nfsc.opl: nfsc_S3.opl
-	@echo $? has been changed.
-	@echo please transfer your changes back to `echo $@ | sed -e 's/^\.//'`
+	@echo ERROR: $? has been modified. Please transfer 
+	@echo ERROR: your changes back to `echo $@ | sed -e 's/^\.//'`
 	@exit 1
 
 opl: nfsc_S3.opl .nfsc.opl
@@ -51,7 +69,7 @@
 tags:
 	ctags -tvs *.c *.h
 
-clean:
+clean celan:
 	rm -f $(PROGRAM) $(OBJS) *pure_* .pure
 
 mp_main.o mp_mount.o mp_pfs_ops.o mp_inode.o: mp.h
diff -u --ignore-all-space p3nfs.pl7/PROBLEMS p3nfs.pl8/PROBLEMS
--- p3nfs.pl7/PROBLEMS	Wed Aug 17 18:28:04 1994
+++ p3nfs.pl8/PROBLEMS	Wed Oct 19 19:53:34 1994
@@ -30,3 +30,15 @@
 4)
 The window server lowers priority of the opl program when it is iconified.
 
+5)
+etc/mtab can become unreadable if the umask of p3nfsd is wrong. This is
+currently fixed for Solaris only. gec
+
+6) WARNING
+When trying to umount /psion/mnt under Solaris 2.3 you will get something
+like:     nfs umount: psion:/ server not responding: RPC: Name to address
+          translation failed - n2a: hostname not found
+Remember to kill p3nfsd afterwards.  An mtab-entry under Solaris looks like:
+ktik0:/var/spool/mail   /var/spool/mail nfs     rw,dev=21c0005 782059425
+Does anybody know what 'dev' is supposed to be? Mail:caronni@tik.ethz.ch
+
diff -u --ignore-all-space p3nfs.pl7/TODO p3nfs.pl8/TODO
--- p3nfs.pl7/TODO	Wed Aug 17 19:52:51 1994
+++ p3nfs.pl8/TODO	Wed Oct 19 14:23:19 1994
@@ -23,6 +23,9 @@
 - lots of unix applications for backup, transfer of program packages,
   auto compression of flash eproms, coffee cooking, etc.. (T)
 - manual page (R)
+- remove r & w permission on files which are currently locked on the
+  psion, map 'modified','hidden','system' to the 3 execution bits? this is 
+  *not* nice, but better than having a separate file for attributes...  (gec)
 
 required ressources: SDK, 3 manyears, 50 pizzas, more cash, less bugreports
 
diff -u --ignore-all-space p3nfs.pl7/config.h p3nfs.pl8/config.h
--- p3nfs.pl7/config.h	Wed Aug 17 19:52:53 1994
+++ p3nfs.pl8/config.h	Wed Oct 19 14:23:19 1994
@@ -22,12 +22,16 @@
 
 #define DUSER "root"
 #ifndef DDIR
-# define DDIR "/psion.stand/mnt"
+# define DDIR "/psion/mnt"
 #endif
 
 #define DSPEED 19200
 
+#if defined(sun) && defined(__svr4__)
+#define MTAB_PATH "/etc/mnttab" /*gec*/
+#else
 #define MTAB_PATH "/etc/mtab"
+#endif
 #ifdef linux
 # define MTAB_TMP  "/etc/mtab~"
 #else
diff -u --ignore-all-space p3nfs.pl7/mp_mount.c p3nfs.pl8/mp_mount.c
--- p3nfs.pl7/mp_mount.c	Wed Aug 17 19:52:54 1994
+++ p3nfs.pl8/mp_mount.c	Wed Oct 19 14:23:19 1994
@@ -20,8 +20,21 @@
 #include "nfs_prot.h"
 
 #ifndef DONT_UPDATE_MTAB
+#if defined(sun) && defined(__svr4__)
+#include <sys/mnttab.h>
+#else
 #include <mntent.h>
 #endif
+#endif
+
+#if defined(sun) && defined(__svr4__) /*gec*/
+#include <nfs/mount.h>
+#include <sys/fstyp.h>
+#include <sys/fsid.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#define PORTMAP
+#endif
 
 #include <sys/socket.h>
 #include <netdb.h>
@@ -55,7 +68,7 @@
       }
   }
 #else
-# ifdef sun
+# if defined(sun) && !defined(__svr4__) /*gec*/
 # define umount unmount
 # endif
   if(umount(mntdir))
@@ -66,6 +79,33 @@
 
 #ifndef DONT_UPDATE_MTAB
   if(debug) printf("unmount succeeded, trying to fix mtab.\n");
+
+#if defined(sun) && defined(__svr4__)
+
+/* it is nasty to have /etc/mnttab with permission 0600 ... gec*/
+  { 
+    struct mnttab entr;
+    mode_t msk=umask(S_IWGRP|S_IWOTH);
+
+    if(!(fpout = fopen(MTAB_TMP, "w"))) {
+        perror(MTAB_TMP); return;
+    }
+
+    if(!(fpin = fopen(MTAB_PATH, "r"))) {
+        fclose(fpout); unlink(MTAB_TMP);
+        perror(MTAB_PATH); exit(0);
+    }
+    (void)umask(msk); 
+  
+    while (!getmntent(fpin,&entr))
+    if(strcmp(entr.mnt_special, NFSHOST) || strcmp(entr.mnt_mountp, mntdir))
+        putmntent(fpout, &entr);
+
+    fclose(fpin); fclose(fpout);
+  }
+
+#else
+
   if(!(fpout = setmntent(MTAB_TMP, "w")))
     {
       perror(MTAB_TMP); return;
@@ -81,6 +121,8 @@
       addmntent(fpout, ent);
   endmntent(fpin); endmntent(fpout);
 
+#endif /* not solaris */
+
   if(rename(MTAB_TMP, MTAB_PATH))
     {
       perror(MTAB_PATH); unlink(MTAB_TMP);
@@ -142,6 +184,7 @@
 /* Bind it to a reserved port */
   sain.sin_family = AF_INET;
   sain.sin_addr.s_addr = inet_addr("127.0.0.1");
+  /*sain.sin_addr.s_addr = htonl(INADDR_ANY);gec*/
   for(port = IPPORT_RESERVED-1; port > IPPORT_RESERVED/2; port--)
     {
       sain.sin_port = htons(port);
@@ -214,6 +257,53 @@
 #endif
 
 #if defined(sun) || defined(hpux)
+#if defined(sun) && defined (__svr4__)
+  { 								/*gec*/
+    struct netbuf myaddr;
+    struct stat stb;
+    struct knetconfig knc;
+    struct netconfig *nc=getnetconfigent("udp");
+    if (!nc) {
+	extern int errno;
+	fprintf(stderr, "getnetconfigent \"udp\": (errno %d) ", errno);
+	perror("");
+	exit(1);
+    }
+    knc.knc_semantics=nc->nc_semantics;
+    knc.knc_protofmly=strdup(nc->nc_protofmly);
+    knc.knc_proto=strdup(nc->nc_proto);
+
+    if (stat(nc->nc_device,&stb)) {
+	extern int errno;
+	fprintf(stderr, "stat \"%s\": (errno %d) ",nc->nc_device, errno);
+	perror("");
+	exit(1);
+    }
+    knc.knc_rdev=stb.st_rdev;
+
+    /*freenetconfigent(nc) has the struct been allocated, or is it static ???*/
+
+    printf("%d,%s,%s,%lx (1,inet,udp,0x002c0029)\n",knc.knc_semantics,
+    knc.knc_protofmly,knc.knc_proto,knc.knc_rdev);
+
+    myaddr.maxlen=myaddr.len=sizeof(sain);
+    myaddr.buf=&sain;
+
+    nfs_args.knconf   = &knc;
+    nfs_args.wsize    = PBUFSIZE;
+    nfs_args.rsize    = PBUFSIZE;
+    nfs_args.addr     = &myaddr;
+    nfs_args.fh       = (char *)root_fh;
+    nfs_args.retrans  = 0;
+    /* 1 minute timeout - means that we receive double requests in worst case,
+     * if the file is longer than 100k */
+    nfs_args.timeo    = 600;
+    nfs_args.hostname = "psion";
+    nfs_args.flags    = NFSMNT_INT | NFSMNT_HOSTNAME | NFSMNT_NOCTO |
+                        NFSMNT_RETRANS | NFSMNT_TIMEO | NFSMNT_WSIZE | 
+			NFSMNT_RSIZE | NFSMNT_KNCONF; 
+  }
+#else
 
   nfs_args.wsize    = PBUFSIZE;
   nfs_args.rsize    = PBUFSIZE;
@@ -226,6 +316,7 @@
   nfs_args.hostname = "psion";
   nfs_args.flags    = NFSMNT_INT | NFSMNT_HOSTNAME | NFSMNT_NOCTO |
                    NFSMNT_RETRANS | NFSMNT_TIMEO | NFSMNT_WSIZE | NFSMNT_RSIZE;
+#endif /* not solaris */
 #endif
 
 #if defined(_IBMR2)
@@ -252,9 +343,13 @@
       default:
 	if(debug)
 	  printf("Going to mount...\n");
-#ifdef sun
+#if defined(sun) && !defined(__svr4__)
 	if(mount("nfs", dir, M_NEWTYPE, &nfs_args))
 #endif
+#if defined(sun) && defined(__svr4__) /*gec*/
+        if(mount("", dir, MS_DATA, "nfs", &nfs_args,sizeof(nfs_args)))
+	/* eventually drop knc-strings now (memory-leak) */
+#endif
 #ifdef hpux
 	if (vfsmount(MOUNT_NFS, dir, 0, &nfs_args))	
 #endif
@@ -274,6 +369,25 @@
 	else
 	  {
 #ifndef DONT_UPDATE_MTAB
+#if defined(sun) && defined(__svr4__) /*gec*/
+	    FILE *mfp;
+	    struct mnttab mnt;
+	    char tim[32];
+
+	    if(debug)
+  	        printf("Mount succeded, making mtab entry.\n");
+	    mnt.mnt_special = NFSHOST;
+	    mnt.mnt_mountp = mntdir;
+	    mnt.mnt_fstype = "nfs";
+	    mnt.mnt_mntopts = "hard,intr"; /* dev=??? */
+	    sprintf(tim,"%ld",time(NULL)); /* umount crashes! without this*/
+	    mnt.mnt_time = tim;
+
+	    if ((mfp = fopen(MTAB_PATH, "a"))) putmntent(mfp, &mnt);
+	    else perror(MTAB_PATH);
+
+	    fclose(mfp);
+#else
 	    FILE *mfp;
 	    struct mntent mnt;
 
@@ -289,6 +403,7 @@
 	    else
 	      perror(MTAB_PATH);
 	    endmntent(mfp);
+#endif /* not solaris */
 #endif
 	  }
 	exit(0);
@@ -298,7 +413,7 @@
   printf("p3nfsd: to stop the server do \"ls %s/exit\". (pid %d)\n",
          mntdir, getpid());
 
-#ifdef sun
+#if defined(sun) && !defined(__svr4__)
   dtbsize = _rpc_dtablesize();
 #else
   dtbsize = FD_SETSIZE;
diff -u --ignore-all-space p3nfs.pl7/mp_pfs_ops.c p3nfs.pl8/mp_pfs_ops.c
--- p3nfs.pl7/mp_pfs_ops.c	Wed Aug 17 18:45:06 1994
+++ p3nfs.pl8/mp_pfs_ops.c	Wed Oct 12 17:12:41 1994
@@ -659,7 +659,7 @@
   fattr *fp;
   unsigned char wop[12];
   struct attrstat *gres;
-  int i,c,len;
+  int c,len;
 
   if(!inode)
     {
diff -u --ignore-all-space p3nfs.pl7/mp_serial.c p3nfs.pl8/mp_serial.c
--- p3nfs.pl7/mp_serial.c	Wed Aug 17 18:45:07 1994
+++ p3nfs.pl8/mp_serial.c	Wed Oct 19 19:47:42 1994
@@ -171,7 +171,7 @@
  * flag first, otherwise we will hang in close(2).
  * (suns that are not "wicked" are "broken" , i.e.: they do not have
  * patch 100513-04. There are also suns that are "wicked" and "broken".
- * These run Solaris >= 2.0 !!
+ * These run Solaris >= 2.0 !! * YESSSSSS!!! gec
  */
 
 void
diff -u --ignore-all-space p3nfs.pl7/mp_xmit.c p3nfs.pl8/mp_xmit.c
--- p3nfs.pl7/mp_xmit.c	Wed Aug 17 18:45:08 1994
+++ p3nfs.pl8/mp_xmit.c	Wed Oct 12 17:12:42 1994
@@ -82,11 +82,11 @@
       return 1;
     }
 
-  if(debug > 1) printf("\tSending: %x, %d\n", p, len);
+  if(debug > 1) printf("\tSending: %#x, %d\n", (unsigned int)p, len);
   while((ret = write(psionfd, p, len)) < len)
     {
       if(debug > 1)
-	fprintf(stderr, "\t\twrite(%d, %#x, %d) = %d\n", psionfd, p, len, ret);
+	fprintf(stderr, "\t\twrite(%d, %#x, %d) = %d\n", psionfd, (unsigned int)p, len, ret);
       if(ret > 0)
 	{
 	  p += ret; len -= ret; continue;
@@ -107,7 +107,7 @@
 	}
     }
   if(debug > 1)
-    fprintf(stderr, "\t\twrite(%d, %#x, %d) = %d\n", psionfd, p, len, ret);
+    fprintf(stderr, "\t\twrite(%d, %#x, %d) = %d\n", psionfd, (unsigned int)p, len, ret);
 
 #ifndef linux
   /*
diff -u --ignore-all-space p3nfs.pl7/nfs_prot_svc.c p3nfs.pl8/nfs_prot_svc.c
--- p3nfs.pl7/nfs_prot_svc.c	Wed Aug 17 18:28:04 1994
+++ p3nfs.pl8/nfs_prot_svc.c	Wed Oct 19 14:23:20 1994
@@ -3,6 +3,7 @@
  * It was generated using rpcgen.
  */
 
+#define PORTMAP
 #include <stdio.h>
 #include <rpc/rpc.h>
 #include "nfs_prot.h"
diff -u --ignore-all-space p3nfs.pl7/nfs_prot_xdr.c p3nfs.pl8/nfs_prot_xdr.c
--- p3nfs.pl7/nfs_prot_xdr.c	Wed Aug 17 18:28:04 1994
+++ p3nfs.pl8/nfs_prot_xdr.c	Wed Oct 19 14:23:20 1994
@@ -3,6 +3,7 @@
  * It was generated using rpcgen.
  */
 
+#define PORTMAP
 #include <rpc/rpc.h>
 #include "nfs_prot.h"
 
@@ -164,6 +165,7 @@
 		if (!xdr_fattr(xdrs, &objp->attrstat_u.attributes)) {
 			return (FALSE);
 		}
+	default:
 		break;
 	}
 	return (TRUE);
@@ -224,6 +226,7 @@
 		if (!xdr_diropokres(xdrs, &objp->diropres_u.diropres)) {
 			return (FALSE);
 		}
+	default:
 		break;
 	}
 	return (TRUE);
@@ -242,6 +245,7 @@
 		if (!xdr_nfspath(xdrs, &objp->readlinkres_u.data)) {
 			return (FALSE);
 		}
+	default:
 		break;
 	}
 	return (TRUE);
@@ -294,6 +298,7 @@
 		if (!xdr_readokres(xdrs, &objp->readres_u.reply)) {
 			return (FALSE);
 		}
+	default:
 		break;
 	}
 	return (TRUE);
@@ -456,6 +461,7 @@
 		if (!xdr_dirlist(xdrs, &objp->readdirres_u.reply)) {
 			return (FALSE);
 		}
+	default:
 		break;
 	}
 	return (TRUE);
@@ -497,6 +503,7 @@
 		if (!xdr_statfsokres(xdrs, &objp->statfsres_u.reply)) {
 			return (FALSE);
 		}
+	default:
 		break;
 	}
 	return (TRUE);
diff -u --ignore-all-space p3nfs.pl7/nfsc.opl p3nfs.pl8/nfsc.opl
--- p3nfs.pl7/nfsc.opl	Wed Aug 17 19:52:56 1994
+++ p3nfs.pl8/nfsc.opl	Wed Oct 12 17:12:45 1994
@@ -4,6 +4,8 @@
 REM the GNU Copyleft (Version 2)
 REM Please send email to jnweiger@immd4.informatik.uni-erlangen.de
 
+REM uadd by Volker Lausch <volli@cs.tu-berlin.de>
+
 proc transmit:
 	local dirnam$(255),hdr$(255),rname$(255),buf$(250)
 	local i%, ret%, cmd%, len%, hdradr%, statadr%
@@ -28,7 +30,14 @@
 		len% = 0 : cmd% = 1
 		iow(-1, 1, #uadd(addr(len%),0), cmd%)
 		ret% = iow(-1, 1, #uadd(hdradr%,0), len%)
-		if ret% : raise ret% : stop : endif
+		if ret%
+		  if ret% = -57
+		    print "@";
+		    continue
+		  endif
+		  raise ret%
+		  stop
+		endif
 rem print "Got:";peekb(hdradr%+len%-1),hdr$,
 		ret% = 7
 		vector peekb(hdradr%+len%-1)
@@ -204,4 +213,12 @@
 	pokel addr(sr%(5)), term&
 	err%=iow(-1,7,sr%(1),dm%)
 	if err% : raise err% : endif
+ENDP
+
+PROC myuadd%:(ad%, of%)
+  LOCAL a&, o&, r%
+  a&=IABS(INT(ad%))
+  o&=IABS(INT(of%))
+  r%=a&+o&
+  RETURN r%
 ENDP
diff -u --ignore-all-space p3nfs.pl7/nfsc_S3.opl p3nfs.pl8/nfsc_S3.opl
--- p3nfs.pl7/nfsc_S3.opl	Thu Aug 18 20:40:47 1994
+++ p3nfs.pl8/nfsc_S3.opl	Wed Oct 19 12:40:05 1994
@@ -5,6 +5,8 @@
 REM the GNU Copyleft (Version 2)
 REM Please send email to jnweiger@immd4.informatik.uni-erlangen.de
 
+REM uadd by Volker Lausch <volli@cs.tu-berlin.de>
+
 proc transmit:
 	local dirnam$(255),hdr$(255),rname$(255),buf$(250)
 	local i%, ret%, cmd%, len%, hdradr%, statadr%
@@ -27,9 +29,16 @@
 	print "Welcome to nfsc, version 2.0 beta, pl7"
 	while 1
 		len% = 0 : cmd% = 1
-		iow(-1, 1, #(addr(len%) + 0), cmd%)
-		ret% = iow(-1, 1, #(hdradr% + 0), len%)
-		if ret% : raise ret% : stop : endif
+		iow(-1, 1, #myuadd%:(addr(len%),0), cmd%)
+		ret% = iow(-1, 1, #myuadd%:(hdradr%,0), len%)
+		if ret%
+		  if ret% = -57
+		    print "@";
+		    continue
+		  endif
+		  raise ret%
+		  stop
+		endif
 rem print "Got:";peekb(hdradr%+len%-1),hdr$,
 		ret% = 7
 		vector peekb(hdradr%+len%-1)
@@ -47,7 +56,7 @@
 
 renm::
 		len% = peekb(hdradr%+len%-2)
-		iow(-1,1,#(addr(dirnam$) + 0),len%)
+		iow(-1,1,#myuadd%:(addr(dirnam$),0),len%)
 		trap rename hdr$, dirnam$
 		lprint chr$(err); : print "n";
 		continue
@@ -91,9 +100,9 @@
 
 		while len%
 			i% = len% : if i% > 250 : i% = 250 : endif
-			iow(-1,1,#(addr(buf$) + 1),i%)
+			iow(-1,1,#myuadd%:(addr(buf$),1),i%)
 			if dowr%
-				ret% = iowrite(wh%, (addr(buf$) + 1), i%)
+				ret% = iowrite(wh%, myuadd%:(addr(buf$),1), i%)
 				if ret% : dowr% = 0 : ioclose(wh%) : endif
 			endif
 			len% = len% - i%
@@ -138,7 +147,7 @@
 
 		while len% > 0
 			i% = len% : if i% > 250 : i% = 250 : endif
-			ret% = ioread(rh%, (addr(buf$) + 1), i%)
+			ret% = ioread(rh%, myuadd%:(addr(buf$),1), i%)
 			roff& = roff& + ret% : len% = len% - ret%
 			pokeb addr(buf$),ret% : lprint buf$;
 			if ret% <> i% : break : endif
@@ -205,4 +214,12 @@
 	pokel addr(sr%(5)), term&
 	err%=iow(-1,7,sr%(1),dm%)
 	if err% : raise err% : endif
+ENDP
+
+PROC myuadd%:(ad%, of%)
+  LOCAL a&, o&, r%
+  a&=IABS(INT(ad%))
+  o&=IABS(INT(of%))
+  r%=a&+o&
+  RETURN r%
 ENDP
diff -u --ignore-all-space p3nfs.pl7/version.h p3nfs.pl8/version.h
--- p3nfs.pl7/version.h	Thu Aug 18 14:39:39 1994
+++ p3nfs.pl8/version.h	Wed Oct 19 14:28:33 1994
@@ -1,6 +1,8 @@
-#define VERSION "2.0 beta, pl7"
-#define DIRSUFFIX .pl7
+#define VERSION "2.0 beta, pl8"
+#define DIRSUFFIX .pl8
 /*
- * 17.08.94 -- pl7:	AIX port (untested) by Rudi. 
- *                      Lee McLoughlin updated the linux port.
+ * 13.10.94 -- pl8:	 Added untested nfsc_S2.opl for classic S3 users.
+ *                       Added preliminary Solaris 2.3 support , gec
+ *			Made it gcc -Wall free.
+ * 30.08.94 -- pl8:	uadd for S3 classic added by Volker Lausch.
  */
Only in p3nfs.pl7: x.opl
Only in p3nfs.pl7: xx.opl
